﻿
package 
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.FullScreenEvent;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	

	public class Zoomer extends Sprite
	{
		private var drawer:Sprite;
		private var data:BitmapData;
		private var background:Bitmap;
		private var cloned:BitmapData;
		private var upground:Bitmap;
		private var counter:Number = 0;
		public function Zoomer()
		{
				addEventListener(Event.ADDED_TO_STAGE,addedHandler);
		}
		
		private function addedHandler(e:Event):void
		{
			setup();
			stage.addEventListener(FullScreenEvent.FULL_SCREEN,fullhandler);
			stage.addEventListener(MouseEvent.MOUSE_OVER,down_handler);
			//stage.addEventListener(MouseEvent.MOUSE_OVER,up_handler);
		}
		private function fullhandler(e:FullScreenEvent):void
		{
			while(numChildren>0){
				this.removeChildAt(0);
			}
			data = null;
			
		}
		
		private function setup():void
		{
			data = new BitmapData(stage.stageWidth,stage.stageHeight,true,0xfffff);
			background = new Bitmap(data);
			addChild(background);
		}
		
		private function down_handler(e:MouseEvent):void
		{
			addEventListener(Event.ENTER_FRAME, enterHandler);
		}
		private function up_handler(e:MouseEvent):void
		{
			removeEventListener(Event.ENTER_FRAME,enterHandler);
			setup();
		}
		
		private function enterHandler(e:Event):void
		{
			if(data == null){
				setup();
			}
			if(counter>1){
				counter = 0;
			}else{
				counter++;
				;
			}
			var my_drawer:Sprite = buildDrawer();
			var support:Sprite = new Sprite();
			my_drawer.x = mouseX;
			my_drawer.y = mouseY;
			my_drawer.scaleY=.1; 
			my_drawer.scaleX=.4;
			support.addChild(my_drawer);
			data.draw(support);
			cloned = data.clone();
			var mul:uint = .9;
			data.merge(cloned,new Rectangle(100,100,stage.stageWidth/.6,stage.stageHeight/.1),new Point(0,counter-10),mul,mul,mul,mul);
		}
		private function buildDrawer():Sprite
		{
			drawer = new Sprite();
			drawer.graphics.beginFill(0x55EF30,0.5 );
			drawer.graphics.drawRect(-stage.stageWidth/Math.random()*1080,stage.stageHeight,1,stage.stageHeight);
			drawer.graphics.drawRect(-stage.stageWidth,stage.stageHeight,stage.stageWidth,-1);
			drawer.graphics.beginFill(0xD3D3D3,.4);
			drawer.graphics.drawRect(-stage.stageWidth,stage.stageHeight,1,stage.stageHeight);
			drawer.graphics.drawRect(-stage.stageWidth,stage.stageHeight,stage.stageWidth,-10);
			drawer.graphics.beginFill(0xD4D6D8,.9);
			drawer.graphics.endFill();
			drawer.rotation= Math.random()*360;
			//drawer. = Math.random()*1080;
			return drawer;
		}
		
	}
}
